#include <stdio.h>
#include <math.h>

int megoldo(double a, double b, double c,  /* együtthatók */
                double *x1, double *x2)             /* gyökök */
{
  double d;                                /* a diszkrimináns */
  int valos;                            /* van-e megoldás */

  valos = 1;
  if (a == 0.0) {
      if (b == 0.0) {                 /* az egyenlet elfajuló */
          valos = 0;
      } else {                                            /* 1. fokú */
          *x1 = -(c / b);
          *x2 = *x1;
      }
  } else {
      d = b * b - 4.0 * a * c;
      if (d < 0.0) {                      /* nincs valós gyöke */
          valos = 0;
      } else {
          *x1 = (-b + sqrt(d)) / (2.0 * a);
          *x2 = (-b - sqrt(d)) / (2.0 * a);
      }
  }
  return valos;
}

int main() {
        double a, b, c, x1, x2;
        printf("Adja meg az egyutthatokat!\n?:");
        scanf("%lf", &a); scanf("%lf", &b); scanf("%lf", &c);
        if(megoldo(a, b, c, &x1, &x2))
                printf("Az egyenlet megoldasai: %lf, %lf\n", x1, x2);
        else
                printf("Az egyenletnek nincs valos megoldasa.\n");
        return 0;
}
